#include "wii.h"

/*xfv=NULL;
rmode=NULL;
*/

#define XOFF 80
#define YOFF 40

char str[4];

void (*wii_reload)() = (void (*) ()) 0x80001800;

u32
CvtRGB (u32 rgb)
{
  u8 r1=(rgb&0xff000000)>>24;
  u8 g1=(rgb&0xff0000)>>16;
  u8 b1=(rgb&0xff00)>>8;     
  u8 r2=r1;
  u8 g2=g1;
  u8 b2=b1;
  int y1, cb1, cr1, y2, cb2, cr2, cb, cr;
 
  y1 = (299 * r1 + 587 * g1 + 114 * b1) / 1000;
  cb1 = (-16874 * r1 - 33126 * g1 + 50000 * b1 + 12800000) / 100000;
  cr1 = (50000 * r1 - 41869 * g1 - 8131 * b1 + 12800000) / 100000;
 
  y2 = (299 * r2 + 587 * g2 + 114 * b2) / 1000;
  cb2 = (-16874 * r2 - 33126 * g2 + 50000 * b2 + 12800000) / 100000;
  cr2 = (50000 * r2 - 41869 * g2 - 8131 * b2 + 12800000) / 100000;
 
  cb = (cb1 + cb2) >> 1;
  cr = (cr1 + cr2) >> 1;
 
  return (y1 << 24) | (cb << 16) | (y2 << 8) | cr;
}


void wii_init()
{
    VIDEO_Init();
    PAD_Init();
    
    switch(VIDEO_GetCurrentTvMode()) {
        case VI_NTSC:
            rmode = &TVNtsc480IntDf;
            break;
        case VI_PAL:
            rmode = &TVPal528IntDf;
            break;
        case VI_MPAL:
            rmode = &TVMpal480IntDf;
            break;
        default:
            rmode = &TVNtsc480IntDf;
            break;
    }

    xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
    console_init(xfb,20,rmode->xfbHeight/2,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
    
    VIDEO_Configure(rmode);
    VIDEO_SetNextFramebuffer(xfb);
    VIDEO_SetBlack(FALSE);
    VIDEO_Flush();
    VIDEO_WaitVSync();
    if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

}

void wii_close()
{
}

char *wii_update(int *colors,int *pieces)
{
    int cx=4,cy=4;
    int ocx=-1,ocy=-1;

    int x,y;

    for(y=0;y<248;y++)
        for(x=0;x<320;x++)
            xfb[x+320*y]=COLOR_BLACK;

    while(1)
    {

    VIDEO_WaitVSync();
    int x,y;
    int bx,by;
    
    for(x=0;x<8;x++)
        for(y=0;y<8;y++)
             for(bx=0;bx<21;bx++)
                for(by=0;by<21;by++)
                {   
                    if(x==cx && y==cy)
                        xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(0xFFA500FF);
                    else if (x==ocx && y==ocy)
                        xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(0xC1CDC1FF);
                    else if(((x+8*y)%2)^(y%2))
                        xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(0x8B4513FF);
                    else
                        xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(0xF4A460FF);
                    u32 color;
                    switch(colors[x+y*8])
                    {   
                        case 1:
                            switch(pieces[x+y*8])
                            {
                        case 0:
                            color = pdd21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 5:
                            color = kdd21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 4:
                            color = qdd21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 2:
                            color = bdd21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 1:
                            color = ndd21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 3:
                            color = rdd21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                            }
                        case 0:
                            switch(pieces[x+y*8])
                            {
                        case 4:
                            color = qld21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 2:
                            color = bld21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 1:
                            color = nld21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 3:
                            color = rld21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 0:
                            color = pld21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        case 5:
                            color = kld21[by+bx*21];
                            if(color!=0xFFFFFFFF)
                                xfb[(x*21+bx+XOFF)+320*(y*21+by+YOFF)]=CvtRGB(color);
                            break;
                        }
                    }
                }
 
        PAD_ScanPads();
        if (PAD_ButtonsDown(0) & PAD_BUTTON_START){
            wii_reload();
        }
        if (PAD_ButtonsDown(0) & PAD_BUTTON_DOWN)
            cy=(cy+1)%8;
        if (PAD_ButtonsDown(0) & PAD_BUTTON_UP)
        {
            cy=(cy-1)%8;
            if(cy<0)
                cy=7;
        }
        if (PAD_ButtonsDown(0) & PAD_BUTTON_LEFT)
        { 
           cx=(cx-1)%8;
           if(cx<0)
            cx=7;
        }
        if (PAD_ButtonsDown(0) & PAD_BUTTON_RIGHT)
            cx=(cx+1)%8;
        if (PAD_ButtonsDown(0) & PAD_BUTTON_A)
        {
            ocx=cx;
            ocy=cy;
        }
        if (PAD_ButtonsDown(0) & PAD_BUTTON_B)
        {
            //return "help";
            str[0]='a'+ocx;
            str[1]='1'+(7-ocy);
            str[2]='a'+cx;
            str[3]='1'+(7-cy);
            return str;
        }
    }
}
